package dados.exception;

import dados.locacao.Copia;
import dados.locacao.Periodo;
import dados.usuario.Cliente;

public class ReservaInvalidaException extends Exception {

	private static final long serialVersionUID = 1L;

	private Copia copia;
	private Cliente cliente;
	private Periodo periodoReserva;
	
	public ReservaInvalidaException(Cliente cliente, Copia copia, Periodo periodo) {
		super("Parmetros invlidos na construo da reserva");
		
		this.cliente = cliente;
		this.copia = copia;
		this.periodoReserva = periodo;
	}

	public Copia getCopia() {
		return this.copia;
	}

	public Cliente getCliente() {
		return this.cliente;
	}

	public Periodo getData() {
		return this.periodoReserva;
	}

}
