package dados.locacao;

import java.io.Serializable;

import javax.persistence.CascadeType;
import javax.persistence.Embeddable;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

import dados.usuario.Cliente;

@Embeddable
public class ClienteCopiaPK implements Serializable {

	private static final long serialVersionUID = 1L;

	@ManyToOne(optional=false, cascade = CascadeType.ALL, fetch=FetchType.EAGER)
	@JoinColumn(name="id_Copia")
	private Copia copia;
	
	@ManyToOne(optional=false, cascade = CascadeType.ALL, fetch=FetchType.EAGER)
	@JoinColumn(name="id_Cliente")
	private Cliente cliente;
	
	public ClienteCopiaPK(Copia copia, Cliente cliente) {
		this.setCliente(cliente);
		this.setCopia(copia);
	}
	
	public ClienteCopiaPK() {}

	public void setCopia(Copia copia) {
		this.copia = copia;
	}

	public Copia getCopia() {
		return copia;
	}

	public void setCliente(Cliente cliente) {
		this.cliente = cliente;
	}

	public Cliente getCliente() {
		return cliente;
	}
	
	@Override
	public boolean equals(Object obj) {
		boolean retorno = obj instanceof ClienteCopiaPK;
		
		if(retorno){
			ClienteCopiaPK l = (ClienteCopiaPK) obj;
			
			retorno = this.cliente.equals(l.getCliente()) && this.copia.equals(l.getCopia());
		}
		
		return retorno;
	}
	
	@Override
	public int hashCode() {
		return (int)(this.cliente.hashCode()* + this.copia.hashCode());
	}
	
}
