package dados.locacao;

import java.io.Serializable;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import dados.exception.CopiaInvalidaException;
import dados.exception.FilialInvalidaException;
import dados.filial.Filial;
import dados.produto.Produto;

@Entity
@Table(name="Copia")
public class Copia implements Serializable{
	
	private static final long serialVersionUID = 3724850271191451867L;
	
	@Id
	@Column(name="id_Copia")
	private Integer codigoCopia;
	
	@ManyToOne(cascade = {CascadeType.MERGE, CascadeType.PERSIST, CascadeType.REFRESH}, optional=false)
    @JoinColumn(name="id_Produto")
    private Produto produto;
	
	@ManyToOne(cascade = {CascadeType.MERGE, CascadeType.PERSIST, CascadeType.REFRESH}, optional=false)
    @JoinColumn(name="id_Filial")
	private Filial filial;
	
	public Copia() {}
	
	public Copia(int codigoCopia, Filial filial, Produto produto) throws CopiaInvalidaException {
		if(produto != null){
			this.codigoCopia = codigoCopia;
			this.produto = produto;
			this.filial = filial;
		}else{
			throw new CopiaInvalidaException();
		}
	}
	
	public int getCodigoCopia(){
		return this.codigoCopia;
	}
	
	public void setCodigoCopia(int codigo){
		this.codigoCopia = codigo;
	}
	
	public Filial getFilial(){
		return this.filial;
	}
	
	public void setFilial(Filial f) throws FilialInvalidaException {
		if(f != null){
			this.filial = f;
		}else{
			throw new FilialInvalidaException();
		}
	}
	
	@Override
	public boolean equals(Object obj) {
		return obj instanceof Copia && this.codigoCopia == ((Copia)obj).getCodigoCopia();
	}

	public Produto getProduto() {
		return this.produto;
	}

	public void setProduto(Produto produto) {
		this.produto = produto;
	}

}
