package dados.locacao;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;

import dados.exception.PromocaoInvalidaException;
import dados.produto.LinkFoto;

@Entity
@Table(name="Promocao")
public class Promocao implements Serializable {
	
	private static final long serialVersionUID = -984326997945106673L;

	@Id
	@Column(name="nome_Promocao")
	private String nome;
	
	@Column(name="id")
	@GeneratedValue
	private long id;
	
	@Column(updatable=true, name="Descricao", nullable=false)
	private String descricao;
	
	@Enumerated
	private LinkFoto foto;
	
	public Promocao() {}

	public Promocao(String nome, String descricao, LinkFoto foto) throws PromocaoInvalidaException{
		if(nome != null && !nome.isEmpty() && descricao != null && !descricao.isEmpty() && foto != null){
			this.nome = nome;
			this.descricao = descricao;
			this.foto = foto;
		}else{
			throw new PromocaoInvalidaException();
		}
	}

	public String getNome() {
		return this.nome;
	}

	public void setNome(String novo) {
		this.nome = novo;
	}

	public String getDescricao() {
		return descricao;
	}

	public void setDescricao(String descricao) {
		this.descricao = descricao;
	}

	@Override
	public boolean equals(Object o) {
		return o instanceof Promocao && this.descricao.equals(((Promocao)o).getDescricao());
	}

	public LinkFoto getFoto() {
		return this.foto;
	}

	public void setFoto(LinkFoto foto) {
		this.foto = foto;
	}

	public long getId() {
		return id;
	}

	public void setId(long id) {
		this.id = id;
	}
}
