package dados.produto;

import java.io.Serializable;

import javax.persistence.CascadeType;
import javax.persistence.Embeddable;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

import dados.usuario.Usuario;

@Embeddable
public class AvaliacaoProdutoPK implements Serializable {

	private static final long serialVersionUID = -4535361273979947126L;

	@ManyToOne(cascade = {CascadeType.MERGE, CascadeType.PERSIST, CascadeType.REFRESH}, optional=false, fetch=FetchType.EAGER)
    @JoinColumn(name="id_Usuario")
	private Usuario usuario;

	@ManyToOne(cascade = {CascadeType.MERGE, CascadeType.PERSIST, CascadeType.REFRESH}, optional=false, fetch=FetchType.EAGER)
    @JoinColumn(name="id_Produto")
	private Produto produto;

	public AvaliacaoProdutoPK(Usuario usuario, Produto produto){
		this.setUsuario(usuario);
		this.setProduto(produto);
	}
	
	public AvaliacaoProdutoPK() {}

	public void setUsuario(Usuario usuario) {
		this.usuario = usuario;
	}

	public Usuario getUsuario() {
		return usuario;
	}

	public void setProduto(Produto produto) {
		this.produto = produto;
	}

	public Produto getProduto() {
		return produto;
	}
	
	@Override
	public boolean equals(Object obj) {
		boolean retorno = obj instanceof AvaliacaoProdutoPK;
		
		if(retorno){
			AvaliacaoProdutoPK a = (AvaliacaoProdutoPK) obj;
			
			retorno = a.produto.equals(this.produto) && a.usuario.equals(this.usuario);
		}
		
		return retorno;
	}
	
	@Override
	public int hashCode() {
		return (int) (this.produto.hashCode() + this.usuario.hashCode());
	}
	
}
