package dados.produto;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;

import dados.exception.PrecoInvalidoException;

@Entity
@Table(name="ClassificaoPreco")
public class ClassificacaoPreco implements Serializable{

	private static final long serialVersionUID = 7398906111229438986L;

	@Id
	@Column(name="Descrio")
	private String descricao;
	
	@Column(name="id")
	@GeneratedValue
	private long id;
	
	@Column(name="Preo", nullable = false)
	private double preco;
	
	public ClassificacaoPreco(String descricao, double d) throws PrecoInvalidoException, ClassificacaoPrecoInvalida {
		if(d >= 0){
			if(descricao != null && !descricao.isEmpty()){
				this.descricao = descricao;
				this.preco = d;
			}else{
				throw new ClassificacaoPrecoInvalida(descricao);
			}
		}else{
			throw new PrecoInvalidoException(d);
		}
	}
	
	public ClassificacaoPreco() {}
	
	public Double getPreco(){
		return this.preco;
	}
	
	public void setPreco(double d) throws PrecoInvalidoException{
		if(d > 0.0){
			this.preco = d;
		}else{
			throw new PrecoInvalidoException(d);
		}
	}
	
	public String getDescricao(){
		return this.descricao;
	}
	
	@Override
	public String toString() {
		return String.format("%s - R$ %.2f", this.descricao, this.preco);
	}

	public long getId() {
		return id;
	}

	public void setId(long id) {
		this.id = id;
	}
	
}
