package dados.produto;

import java.io.Serializable;

public class CriterioBusca implements Serializable {
	
	private static final long serialVersionUID = 1151729280065846254L;

	private Integer ano;

	private String nome;
	private String censura;
	private String classificacaoPreco;
	private String empresa;
	private String genero;
	
	private TipoProduto tipo;
	
	public CriterioBusca(TipoProduto tipo, String nome, String genero, String empresa, String classificacao, String censura, Integer ano) {
		this.nome = this.filtro(nome);
		this.genero = this.filtro(genero);
		this.empresa = this.filtro(empresa);
		this.classificacaoPreco = this.filtro(classificacao);
		this.censura = this.filtro(censura);
		this.ano = ano;
		this.tipo = tipo;
	}
	
	private String filtro(String entrada){
		if(entrada != null){
			if(entrada.isEmpty()){
				return null;
			} else {
				return entrada;
			}
		} else {
			return null;
		}
	}

	public Integer getAno() {
		return this.ano;
	}

	public String getNome() {
		return this.nome;
	}

	public String getCensura() {
		return this.censura;
	}

	public String getClassificacaoPreco() {
		return this.classificacaoPreco;
	}

	public String getEmpresa() {
		return this.empresa;
	}

	public String getGenero() {
		return this.genero;
	}

	public TipoProduto getTipo() {
		return this.tipo;
	}

	public boolean aceita(Produto p) {
		boolean retorno = true;
		
		if((this.nome != null && !p.getNome().equalsIgnoreCase(this.nome))
				|| (this.ano != null && !this.ano.equals(p.getAnoLancamento()))
				|| (this.censura != null && !this.censura.equalsIgnoreCase(p.getCensura()))
				|| (this.empresa != null && !this.empresa.equalsIgnoreCase(p.getEmpresaProdutora()))
				|| (this.genero != null && !this.genero.equalsIgnoreCase(p.getGenero()))
				|| (this.classificacaoPreco != null && !this.classificacaoPreco.equalsIgnoreCase(p.getClassificacaoPreco().getDescricao()))){
			retorno = false;
		}
		
		return retorno;
	}

}
