package dados.produto;

import javax.persistence.Column;
import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;

import negocio.exception.LinkFotoExistenteException;
import util.IteratorBidirecional;

import dados.exception.ProdutoInvalidoException;

@Entity
@DiscriminatorValue("Msica")
public class Musica extends Produto {
	
	private static final long serialVersionUID = 3088322150534958199L;
	
	@Column(updatable=true, name="Artista", nullable=false)
	private String artista;
	
	public Musica() {}
	
	public Musica(String nome, String genero, String censura, String artista,
			String descricao, String empresaProdutora, String linkTrailer,
			ClassificacaoPreco classificacao, Integer ano) throws ProdutoInvalidoException {
		super(nome, genero, censura, descricao, empresaProdutora, linkTrailer, classificacao, ano);
		
		if(artista != null){
			this.artista = artista.trim();
		}else{
			throw new ProdutoInvalidoException();
		}
	}

	public String getArtista() {
		return this.artista;
	}

	public void setArtista(String artista) throws ProdutoInvalidoException {
		if(artista != null){
			this.artista = artista.trim();
		}else{
			throw new ProdutoInvalidoException();
		}
	}
	
	@Override
	public boolean equals(Object arg0) {
		return super.equals(arg0);
	}

	@Override
	public void setDados(Produto dados) throws ProdutoInvalidoException {
		if(dados != null && dados instanceof Musica){
			Musica d = (Musica) dados;
			
			this.setAnoLancamento(d.getAnoLancamento());
			this.setCensura(d.getCensura());
			this.setClassificacaoPreco(d.getClassificacaoPreco());
			this.setDescricao(d.getDescricao());
			this.setEmpresaProdutora(d.getEmpresaProdutora());
			this.setGenero(d.getGenero());
			this.setLinkTrailer(d.getLinkTrailer());
			this.setNome(d.getNome());
			this.setNota(dados.getNota());
			this.setArtista(d.getArtista());
			
			IteratorBidirecional<LinkFoto> it = dados.getLinks();

			this.linkFotos.limpar();
			while(it.hasNext()){
				try {
					this.inserirLinkFoto(it.next());
				} catch (LinkFotoExistenteException e) {
				}
			}
		}else{
			throw new IllegalArgumentException();
		}
	}

}
