package dados.usuario;

import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;

import negocio.exception.SenhaInvalidaException;
import dados.exception.CpfInvalidoException;
import dados.exception.EmailInvalidoException;
import dados.exception.NomeInvalidoException;

@Entity
@DiscriminatorValue("Administrador")
public class Administrador extends Usuario {

	private static final long serialVersionUID = 9180670530794508359L;

	public Administrador() {}

	public Administrador(long cpf, String senha, String nome, String email) throws NomeInvalidoException, SenhaInvalidaException, CpfInvalidoException, EmailInvalidoException {
		super(cpf, senha, nome, email);
	}

	@Override
	public boolean temPermissaoCadastro(Usuario user) {
		if(user != null){
			return true;
		}else{
			throw new IllegalArgumentException();
		}
	}

	@Override
	public boolean temPermissaoRemocao(Usuario user) {
		if(user != null){
			boolean retorno = true;

			if(user instanceof Administrador){
				retorno = this.equals(user);
			}

			return retorno;
		}else{
			throw new IllegalArgumentException();
		}
	}

	@Override
	public void setDados(Usuario usuario) {
		if(usuario != null && usuario instanceof Administrador){
			try {
				this.setSenha(usuario.getSenha());
				this.setEmail(usuario.getEmail());
				this.setNome(usuario.getNome());
			} catch (SenhaInvalidaException e) {
				// NAO deve acontecer
			} catch (EmailInvalidoException e) {
				// NAO deve acontecer
			} catch (NomeInvalidoException e) {
				// NAO deve acontecer
			}
		}else{
			throw new IllegalArgumentException();
		}
	}

	@Override
	public boolean temPermissaoAlteracao(Usuario user) {
		return this.temPermissaoRemocao(user);
	}

}
