package teste;
import junit.framework.Assert;

import org.junit.Test;

import dados.exception.EnderecoInvalidoException;
import dados.exception.FilialInvalidaException;
import dados.exception.TelefoneInvalidoException;
import dados.filial.Endereco;
import dados.filial.Filial;
import dados.usuario.Telefone;


public class FilialTeste {

	/**
	 * Teste de unidade da classe Filial, feito para ver as principais operaes
	 * realizadas pela mesma.
	 */
	@Test
	public void testeFilial(){
		try {
			Endereco e = new Endereco("logradouro", "es", "cidade", "bairro", "complemento", 10, 12345698);
			Telefone t = new Telefone(81, 34560660);
			
			Filial filial = new Filial("Filial", t, e);
			Assert.assertNotNull(filial);
			
			Assert.assertEquals(filial.getEndereco(), e);
			Assert.assertEquals(filial.getTelefone(), t);
		} catch (FilialInvalidaException e) {
			Assert.assertTrue(false);
		} catch (TelefoneInvalidoException e) {
			Assert.assertTrue(false);
		} catch (EnderecoInvalidoException e) {
			Assert.assertTrue(false);
		}
		
		try {
			Filial filial = new Filial("Filial", null, null);
			Assert.assertNull(filial);
		} catch (FilialInvalidaException e) {
			Assert.assertTrue(true);
		}
		
	}
	
}
