package teste;

import junit.framework.Assert;

import org.junit.Test;

import dados.exception.PrecoInvalidoException;
import dados.exception.ProdutoInvalidoException;
import dados.produto.ClassificacaoPreco;
import dados.produto.ClassificacaoPrecoInvalida;
import dados.produto.Filme;
import dados.produto.Produto;
import dados.produto.Serie;

public class ProdutoTeste {
	
	/**
	 * Teste de unidade da classe Produto, feito para ver as principais operaes
	 * realizadas pela mesma.
	 */
	@Test
	public void testeProduto(){
		try {
			Produto produto = new Filme("Filme", "genero", "censura", "descricao", "empresaProdutora", "linkTrailer", "diretor", "autor", new ClassificacaoPreco("descricao", 0), 10, 200);
			Assert.assertNotNull(produto);
			produto = new Serie("nome", "genero", "censura", "descricao", "empresaProdutora", "linkTrailer", new ClassificacaoPreco("descricao", 0), 100, 1, 1, 10);
			Assert.assertNotNull(produto);
		} catch (ProdutoInvalidoException e) {
			Assert.assertTrue(false);
		} catch (PrecoInvalidoException e) {
			Assert.assertTrue(false);
		} catch (ClassificacaoPrecoInvalida e) {
			Assert.assertTrue(false);
		}
		
	}

}
